
ArrayList<Threads> threads; //Ablage für die verschiedenen Threads
int nummerThread;
int[][] Matrix;//für Konvergenz
int[][] MatrixTemp;
int[][] MatrixGesamt;
int[] z;
String[] permSchluessel;
int n;
double a,b,c,d;
double abstand = 0.000001;
double delta;
int anzahlThreads = 12;
PImage  bild,bildErgebnis;
boolean restart = false;
int cols,rows,Cols,Rows;
int m = 256; //Anzahl Folgepunkte für sw für schnelle Suche
int bL = 10;//Blinddurchläufe
int konvTestBis = 500;
int part;//in size passend machen
float  G = 20;
float xZ =0;
float yZ =0;
float minX = -G+xZ;
float maxX =  G+xZ;
float minY = -G+yZ;
float maxY =  G+yZ;
float wh = maxX-minX;
float dK;
float sW ;
float vFaktor = 0.5;
float vergroesserung = 1.0;
float[]SA;//Summe Abstand
float[]SW;//Summe Winkel
double xH,yH;
color f;
float anteil =2*G/(float)anzahlThreads;//y-Anteil für jeden Thread

void setup(){
  size(1200,1200);//cols durch anzahlThreads teilbar
  cols = width;Cols = 2*cols;
  rows = height;//Rows = 2*rows;
  background(0);
  n = Cols*rows;
  permSchluessel = new String[n];
  sW = 2*G/(float)Cols;
  dK = 2*G/(float)anzahlThreads;
  part =Cols/anzahlThreads;
  z = new int[Cols];
   textSize(24);
  text("Ver- und Entschlüsseln mit Clifford Attraktor", 40, 40); 
  text("Verwenden Sie die Tasten:", 40, 100); 
  text("<s> für das erstellen eines Bild-Schlüssels. (Dauert ein-zwei Minuten)",40, 140);  
  text("<v> für das Verschlüsseln eines Bildes. Das Bild bild.bmp muss sich im data-Ordner befinden.",40,180);
  text("        bild.bmp muss die Größe 1200x1200 haben", 40,260);
  text("        Ebenso auch der Bildschlüssel schluesselXOR.bmp", 40,220);
  text("<e> für das Entschlüsseln eines Bildes.", 40, 300);   
  text("        schluesselXOR.bmp und bildVerschluesselt.bmp müssen sich im data-Ordner befinden ", 40, 340); 
 // a = random(-2.5,2.5); b = random(-2.5,2.5); c = random(-2.5,2.5); d = random(-2.5,2.5);  delta = random(2.5,5.5);
  //a = 0.9188442;  b = 2.4275956;  c = 2.1944933;  d = -1.5525020; delta = 3.8372982;
  //a = -0.03441095;  b = -1.64023375;  c = -0.65186560;  d = -0.52357173;  delta = 3.97846222;
   a = -0.07644462585449219;  b = 2.015718460083008;  c = 0.8257880210876465;  d = 0.7095649242401123;  delta = 2.6392455101013184;


  println("a = "+a+";  b = "+b+";  c = "+c+";  d = "+d+";  delta = "+delta+"; ");
}
/////////////////////////////////////////////////////////////////
void draw(){ 
  if(restart){     
    println("Gestartet!");    
    Matrix = new int[Cols][rows];
    MatrixTemp = new int[Cols][rows];   
    MatrixGesamt =  new int[Cols][rows];     
    for (int i = 0; i < Cols; i ++ ) {
      for (int j = 0; j < rows; j ++ ) {
        Matrix[i][j] = 0;
        MatrixTemp[i][j] = 0;
        MatrixGesamt[i][j]= 0;     
      }
    }        
    nummerThread =0;
    
    threads = new  ArrayList<Threads>(); //Initialisierung  
    while(nummerThread <anzahlThreads){
        Threads t = new Threads(nummerThread);//Initialisierung
        threads.add(t); //Thread zur ArrayList hinzufügen
        t.start();  //Start des aktuellen Thread
        nummerThread ++;
    }    
    for(Threads t: threads){
        while (t.running){    //warten bis alle Threads fertig sind   
              try{
              Thread.sleep(10);  
              }catch (Exception e) {  }  ;                
         }
         if(t.gibNummer() ==0){
           //println("fertig!");
         }      
    }
   //Abrufen der Teilergebnisse   
   for(int K=0; K< anzahlThreads;K++){       
      for (int i = 0; i < Cols; i ++ ) {
         for (int j = 0; j < rows; j ++ ) {        
           MatrixTemp[i][j] = threads.get(K).MErgebnis[i][j][K]; 
           Matrix[i][j] = Matrix[i][j]+ MatrixTemp[i][j];
        }
      }     
   }  
   
  for (int i = 0; i < Cols; i ++ ) {
         for (int j = 0; j < rows; j ++ ) {                      
             MatrixGesamt[i][j]= Matrix[i][j];         
         }
   } 
        
   zeichnen();    
   println("a = "+a+";  b = "+b+";  c = "+c+";  d = "+d+";  delta = "+delta);
   restart = false;   
   }
}
//////////////////////////////////////////////////////////////////
void zeichnen(){
   bild = loadImage("bild.bmp");
  image(bild,0,0); 
  permSchluessel = arrayVonMatrix(MatrixGesamt);
  saveStrings("data/permSchluessel.txt", permSchluessel);
 //for(int i=0; i<cols;i++) println(i+" ; "+z[i]);//Verteilung analysieren
  
}
//////////////////////////////////////////////////////////////////
String[] arrayVonMatrix(int[][] matrix){  
   int[][] MatrixHisto = matrix;
   String[]schluessel = new String[n];
    for(int i = 0; i < Cols ; i++){
         for(int j = 0; j < rows; j++){ 
           
            String x = str(round(MatrixHisto[i][j])% cols);
            int X = Integer.parseInt(x);
            z[X]++;
            schluessel[i + j*Cols] = x;
           }           
    }            
 return schluessel;
}

void keyPressed(){  
  if(key == 'v'){    
     println("Bild wird verschlüsselt!");    
     bildErgebnis = loadImage("data/bild.bmp");
     permSchluessel = loadStrings("data/permSchluessel.txt");
     int ax, ay, bx, by;
     color tauschA = color(0,0,0);
     color tauschB = color(0,0,0);
     
     for(int i=0;i<cols;i++){
       for(int j=0;j<rows;j++){
         int nummer = 2*(i+j*cols);
         ax=Integer.parseInt(permSchluessel[nummer]);
         ay=Integer.parseInt(permSchluessel[nummer+1]);
         bx=i;by=j;
         tauschA = bildErgebnis.get(ax,ay);
         tauschB = bildErgebnis.get(bx,by);
         bildErgebnis.set(ax,ay,tauschB) ;
         bildErgebnis.set(bx,by,tauschA) ;
       }      
     }
     
     bildErgebnis.save("data/bildVerschluesselt.bmp");
     bild = loadImage("data/bildVerschluesselt.bmp");
     image(bild,0,0);  
     println("Verschlüsselung beendet!");   
  }
  if(key == 'e'){
     println("Bild wird entschlüsselt!");
     bildErgebnis = loadImage("data/bildVerschluesselt.bmp");
     permSchluessel = loadStrings("data/permSchluessel.txt");
     int ax, ay, bx, by;
     color tauschA = color(0,0,0);
     color tauschB = color(0,0,0);
     println(cols-1,rows-1);
     
     for(int i=cols-1;i>=0;i--){
       for(int j=rows-1;j>=0;j--){
         int nummer = 2*(i+j*cols); 
         bx=Integer.parseInt(permSchluessel[nummer]);
         by=Integer.parseInt(permSchluessel[nummer+1]);
         ax=i;ay=j;
         tauschA = bildErgebnis.get(bx,by);
         tauschB = bildErgebnis.get(ax,ay);
         bildErgebnis.set(bx,by,tauschB) ;
         bildErgebnis.set(ax,ay,tauschA) ;
       }      
     }
    
     bildErgebnis.save("data/bildEntschluesselt.bmp");
     bild = loadImage("data/bildEntschluesselt.bmp");
     image(bild,0,0);  
     println("Entschlüsselung beendet!");   
    
    
  }
  if(key == 's'){
    println("Permschlüssel erzeugen!");
    restart = true;    
  }
  
}
 
 
 
 
